#include "Graph.h"
#include "BFS.h"
#include <string>
#include <iostream>
#include <map>
#include <vector>
#include <queue>

using namespace std;

BFS::BFS(Graph G, int s)
{
	marked.resize(G.V);
	distTo.resize(G.V);
	edgeTo.resize(G.V);

	for(int i=0;i < G.V; i++)
	{
		marked[i] = false;
		distTo[i] = 0;
		edgeTo[i] = 0;
	}

	bfsSearch(G, s);
}

BFS::~BFS()
{
}


bool BFS::hasPathTo(int v)
{
	return marked[v];
}

int BFS::showDistTo(int v)
{
	return distTo[v];
}

vector<int> BFS::pathTo(int v)
{

	vector<int> path;
	if(!hasPathTo(v)) { return path; }
	int i;
	for(i = v; distTo[i] != 0; i = edgeTo[i])
	{
		path.push_back(i);
	}
	path.push_back(i);
	return path;
}

void BFS::bfsSearch(Graph G, int s)
{
	queue<int> Q;
	for(int i = 0; i < G.V; i++)
	{
		distTo[i] = infinity;
	}
	distTo[s] = 0;
	marked[s] = true;
	Q.push(s);
	while( Q.size() > 0 )
	{
		int v = Q.front();
		Q.pop();
		for(int j = 0; j < G.adj[v].size(); j++)
		{
			int w = G.adj[v][j];
			if(!marked[w])
			{
				edgeTo[w] = v;
				distTo[w] = distTo[v] + 1;
				marked[w] = true;
				Q.push(w);
			}
		}
	}
}