#include <iostream>
#include <string>
#include <list>
#include "Symbol.h"
#include "BFS.h"

using namespace std;


void main()
{

	
	SymbolGraph* SG = new SymbolGraph(); 
	Graph G = SG->getGraph();

	int s = SG->index("Bacon, Kevin");
	BFS* bfsSearch = new BFS(G,s);

	char input[100];
	string Actor;
	string choice;
	bool quit = false;
	while(!quit)
	{
		//ask user to input actor to find
		cout << "Please Enter Actor Name to Find his Bacon Number" << endl;
		cout << "Enter in Format of 'Last Name, First Name' please:" << endl;
		cin.getline(input,100);

		Actor = input;
		cout << endl;


		if(SG->contains(Actor))
		{
			int t = SG->index(Actor);
			if(bfsSearch->hasPathTo(t))
			{
				vector<int> path = bfsSearch->pathTo(t);

				for(int i = 0; i < path.size(); i++)
				{
					cout << SG->name(path[i]) << " also stars / stars in " << endl;
				}

				cout << Actor << "'s Bacon Number is: " << bfsSearch->showDistTo(t)/2 << endl;
			}
			else 
			{
				cout << "Not Connected to Kevin Bacon" << endl;
			}

		}
		else 
		{
			cout << "Not in Database" << endl;
		}
		
		cout << "Go Again Y/N?" << endl;
		cin.getline(input,100);
		choice = input;
		if(choice == "Y" || choice == "y")
		{
			quit = false;
		}
		else
		{
			quit = true;
		}
	}

}